---------------------------------------------------------------------------------------------------------------
-- RISA Project
-- Author: A.Greensted
-- Module:
-- Description:
-- History:
---------------------------------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity PulseGenerator is
	port (	clk					: in	std_logic;
				nReset				: in	std_logic;
				enable				: in	std_logic;
				input					: in	std_logic;
				pulse					: out	std_logic);

end PulseGenerator;

architecture General of PulseGenerator is

	signal oldInput : std_logic;

begin

pulse <= input and (not oldInput);

PulseGen : process(clk)
begin

	if (clk'event and clk='1') then

		if (nReset='0') then
			oldInput <= '0';

		elsif (enable='1') then
			oldInput <= input;

		end if;

	end if;

end process;

end General;
