---------------------------------------------------------------------------------------------------------------
-- RISA Project
-- Author: A.Greensted
-- Module:
-- Description:
-- History:
---------------------------------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity PulseSynchroniser is
	port (	clk					: in		std_logic;
				dIn					: in		std_logic;
				dOut					: out		std_logic);

end PulseSynchroniser;

-----------------------------------------------------------------------------------------
-- General - Simulation
-----------------------------------------------------------------------------------------
--architecture General of EdgeSynchroniser is

--	signal stage1	: std_logic;
--	signal stage2	: std_logic;
--	signal stage3	: std_logic;

--begin

--dOut <= stage2 and not stage3;

--Sync : process(clk)
--begin

--	if (clk'event and clk='1') then

--		stage1 <= dIn;
--		stage2 <= stage1;
--		stage3 <= stage2;

--	end if;

--end process;

--end General;

-----------------------------------------------------------------------------------------
-- UMC - For ASIC
-----------------------------------------------------------------------------------------
architecture UMC of PulseSynchroniser is

	signal stage1	: std_logic;
	signal stage2	: std_logic;
	signal stage3	: std_logic;

	component HDDFFPQ2 is
		port (	d	: in	std_logic;
					q	: out	std_logic;
					ck	: in	std_logic);
	end component;

	component HDEXOR2D2 is
		port (	a1	: in	std_logic;		
					a2	: in	std_logic;
					z	: out	std_logic);
	end component;

begin

FF1 : HDDFFPQ2
port map (	d	=> dIn,
				q	=> stage1,
				ck	=> clk);

FF2 : HDDFFPQ2
port map (	d	=> stage1,
				q	=> stage2,
				ck	=> clk);
				
FF3 : HDDFFPQ2
port map (	d	=> stage2,
				q	=> stage3,
				ck	=> clk);

XOR_GATE : HDEXOR2D2
port map (	a1	=> stage2,
				a2 =>	stage3,
				z	=> dOut);

end UMC;
