---------------------------------------------------------------------------------------------------------------
-- RISA Project
-- Author: A.Greensted
-- Module:
-- Description:
-- History:
---------------------------------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity RAM4kx16_150c is
	port (	CK			: in	std_logic;
				ADR		: in	std_logic_vector(11 downto 0);
				DI			: in	std_logic_vector(15 downto 0) := (others => '0');
				WEN		: in	std_logic;
				CEN		: in	std_logic;
				OEN		: in	std_logic;
				DOUT		: out	std_logic_vector(15 downto 0) := (others => '0'));
end RAM4kx16_150c;

architecture Behavourial of RAM4kx16_150c is

	type ram_type is array (4095 downto 0) of std_logic_vector (15 downto 0);
	signal RAM : ram_type := (others => x"0000");

begin

process (CK)
begin
	if (CK'event and CK = '1') then

		if (CEN='0') then

			dOut <= RAM(conv_integer(ADR));

			if (WEN='0') then
				RAM(conv_integer(ADR)) <= DI;

			end if;

		end if;

	end if;

end process;

end Behavourial;
