---------------------------------------------------------------------------------------------------------------
-- RISA Project
-- Author: A.Greensted
-- Module:
-- Description:
-- History:
---------------------------------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity Synchroniser is
	port (	clk					: in		std_logic;
				dIn					: in		std_logic;
				dOut					: out		std_logic);

end Synchroniser;

-----------------------------------------------------------------------------------------
-- General - Simulation
-----------------------------------------------------------------------------------------
architecture General of Synchroniser is

	signal stage1	: std_logic;

begin

Sync : process(clk)
begin

	if (clk'event and clk='1') then
		stage1	<= dIn;
		dOut		<= stage1;

	end if;

end process;

end General;

-----------------------------------------------------------------------------------------
-- UMC - For ASIC
-----------------------------------------------------------------------------------------
--architecture UMC of Synchroniser is
--
--	signal stage1	: std_logic;
--
--	component HDDFFPQ2 is
--		port (	d	: in	std_logic;
--					q	: out	std_logic;
--					ck	: in	std_logic);
--	end component;
--
--begin
--
--FF1 : HDDFFPQ2
--port map (	d	=> dIn,
--				q	=> stage1,
--				ck	=> clk);
--
--FF2 : HDDFFPQ2
--port map (	d	=> stage1,
--				q	=> dOut,
--				ck	=> clk);
--
--end UMC;
